import 'dart:convert';

import 'package:flutter/widgets.dart';
import 'package:universal_platform/universal_platform.dart';
import 'package:webview_flutter/webview_flutter.dart';

class MultiplatformWebview extends StatefulWidget {
  const MultiplatformWebview({
    @required this.src,
  });

  final String src;

  @override
  _MultiplatformWebviewState createState() => _MultiplatformWebviewState();
}

class _MultiplatformWebviewState extends State<MultiplatformWebview> {
  @override
  void initState() {
    super.initState();
    if (UniversalPlatform.isAndroid) WebView.platform = SurfaceAndroidWebView();
  }

  @override
  Widget build(BuildContext context) {
    return WebView(
      initialUrl: widget.src.contains("html")
          ? Uri.dataFromString(
              widget.src,
              mimeType: 'text/html',
              encoding: Encoding.getByName('utf-8'),
            ).toString()
          : widget.src,
      javascriptMode: JavascriptMode.unrestricted,
      navigationDelegate: (action) {
        String currentUrl = action.url;

        print("Current url: $currentUrl");

        if (currentUrl.contains("https://abeinstitute.com/#/")) {
          Navigator.pop(context);
        }

        return NavigationDecision.navigate;
      },
    );
  }
}
